/**
 * There was an error processing the CubicWeb schema.
 */
export class InconsistentSchemaError extends Error {
  constructor(message: string) {
    super(`Inconsistent schema: ${message}`);
    Object.setPrototypeOf(this, new.target.prototype);
  }
}

/**
 * There was an error while validating the data sent to the server.
 */
export class ValidationError extends Error {
  constructor(message: string) {
    super(message);
    Object.setPrototypeOf(this, new.target.prototype);
  }
}
