# CubicwebJS demo

This package provides a simple demo to test the different cubicwebjs packages.

Go to [`cubicweb-demojs/cubicweb_demojs/schema.py`](cubicweb-demojs/cubicweb_demojs/schema.py) to inspect the demo schema.

## Installation

To run the demo, you need to install both the cubicweb instance and the frontend.

### Cubicweb instance

A demo cube to create your instance is provided in the folder `cubicweb_demojs`. Follow these steps to install it.

```sh
# Create a venv and install the cube
cd cubicweb-demojs
python -m venv venv
source venv/bin/activate
pip install -e .

# Create a new instance from the cube
# During the setup, choose sqlite, set admin login and password to "admin" and enable anonymous access.
# Leave everything to defaults.
cubicweb-ctl create demojs demojs 
```

Now open your pyramid.ini (`~/etc/cubicweb.d/demojs/pyramid.ini`) and add
to the section cubicweb.includes` the line `cubicweb_api.auth.routes`.

### Frontend

The frontend is a simple node application. Follow these steps to install it.

```sh
yarn install --immutable
```

## Run

In one terminal, run you backend instance.

```sh
yarn start-cubicweb
```

In another, run the frontend.

```sh
yarn start
```

Navigate to [http://localhost:3000](http://localhost:3000) to access the frontend.
