# @cubicweb/rql-generator

This library exposes a set of helpers to make building RQL transactions simpler.

## Installation

@cubicweb/rql-generator is available from NPM:
```bash
# With NPM
npm i @cubicweb/rql-generator
# Or with Yarn
yarn add @cubicweb/rql-generator
```

## Usage

This library works on an existing transaction object.
This allows you to combine different helpers on the same object to create complex transactions.

Please refer to the documentation of
[`@cubicweb/client`](https://cubicweb.pages.logilab.fr/cubicwebjs/client/index.html)
on how to create the instanceSchema and client parameters.

```js
import { Transaction } from "@cubicweb/client";
import {instanceSchema, client} from "../data"

const transaction = new Transaction()
const { resolveEntity } = pushEntityFromEid(transaction, instanceSchema, 5, "BlogEntry", [
    "title",
    "content"
]);
const result = await client.executeTransaction(transaction)
const entity = resolveEntity(result)
console.log(entity)
// Will print {title: "entity title", content: "entity content"}
```

## Documentation

You can find the full documentation with examples [here](https://cubicweb.pages.logilab.fr/cubicwebjs/rql-generator/index.html).

## Contribute

All `@cubicweb` libraries are in the [cubicwebjs monorepo](https://forge.extranet.logilab.fr/cubicweb/cubicwebjs).
Please refer to the main README. 

## Get Help

Contact us on [Matrix](https://matrix.to/#/#cubicweb:matrix.logilab.org) and check the roadmap on the [CubicWeb Repository](https://forge.extranet.logilab.fr/cubicweb/cubicweb).