import { RelationDefinitionSchema, Schema } from "@cubicweb/client";
import {
  mockBlogSchemaJson,
  MockBlogRawSchema,
  MockRelationRawSchema,
  mockRelationSchemaJson,
} from "@cubicweb/mock-schema";

export const mockBlogSchema = new Schema<
  MockBlogRawSchema["entities"],
  MockBlogRawSchema["relations_definitions"]
>(mockBlogSchemaJson as MockBlogRawSchema);

export const mockRelationSchema = new Schema<
  MockRelationRawSchema["entities"],
  MockRelationRawSchema["relations_definitions"]
>(mockRelationSchemaJson as MockRelationRawSchema);

export const BLOG_ENTRY_ATTRIBUTES = [
  ...mockBlogSchema.getEntity("BlogEntry").attributes,
].sort((a, b) =>
  a.type.localeCompare(b.type)
) as unknown as Array<RelationDefinitionSchema>;

export const BLOG_ENTRY_SUBJECTS = [
  ...mockBlogSchema.getEntity("BlogEntry")!.relationDefinitions.subject,
].sort((a, b) =>
  a.type.localeCompare(b.type)
) as unknown as Array<RelationDefinitionSchema>;

export const BLOG_OBJECTS = [
  ...mockBlogSchema.getEntity("Blog")!.relationDefinitions.object,
].sort((a, b) =>
  a.type.localeCompare(b.type)
) as unknown as Array<RelationDefinitionSchema>;

export const TEST_OBJECT_OBJECTS = [
  ...mockRelationSchema.getEntity("TestObject").relationDefinitions.object,
].sort((a, b) =>
  a.type.localeCompare(b.type)
) as unknown as Array<RelationDefinitionSchema>;

export const TEST_SUBJECT_SUBJECTS = [
  ...mockRelationSchema.getEntity("TestSubject").relationDefinitions.subject,
].sort((a, b) =>
  a.type.localeCompare(b.type)
) as unknown as Array<RelationDefinitionSchema>;
