# @cubicweb/yup

This library exposes a [`yup`](https://github.com/jquense/yup) validator for working with forms.

## Installation

@cubicweb/yup is available from NPM:
```bash
# With NPM
npm i @cubicweb/yup
# Or with Yarn
yarn add @cubicweb/yup
```

## Usage

Here is an example usage with `react-hook-form`:

```ts
import {useForm} from "react-hook-form";
import {yupResolver} from "@hookform/resolvers/yup";
import {getValidationSchemaFromYams} from "@cubicweb/yup";

const entityTypeParser = getValidationSchemaFromYams(
    entityTypeSchema,
    errorsTranslations,
    omittedFields
);
const {...} = useForm({
    resolver: yupResolver(entityTypeParser),
});
```

## Documentation

You can find the full documentation with examples [here](https://cubicweb.pages.logilab.fr/cubicwebjs/yup/index.html).

## Contribute

All `@cubicweb` libraries are in the [cubicwebjs monorepo](https://forge.extranet.logilab.fr/cubicweb/cubicwebjs).
Please refer to the main README. 

## Get Help

Contact us on [Matrix](https://matrix.to/#/#cubicweb:matrix.logilab.org) and check the roadmap on the [CubicWeb Repository](https://forge.extranet.logilab.fr/cubicweb/cubicweb).